require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&MALO_READ_1)) {
    sub MALO_READ_1 {
	my($sc, $reg) = @_;
	eval q( &bus_space_read_1(($sc)-> &sc_iot, ($sc)-> &sc_ioh, ($reg)));
    }
}
unless(defined(&MALO_READ_2)) {
    sub MALO_READ_2 {
	my($sc, $reg) = @_;
	eval q( &bus_space_read_2(($sc)-> &sc_iot, ($sc)-> &sc_ioh, ($reg)));
    }
}
unless(defined(&MALO_READ_MULTI_2)) {
    sub MALO_READ_MULTI_2 {
	my($sc, $reg, $off, $size) = @_;
	eval q( &bus_space_read_raw_multi_2(($sc)-> &sc_iot, ($sc)-> &sc_ioh, ($reg), ($off), ($size)));
    }
}
unless(defined(&MALO_WRITE_1)) {
    sub MALO_WRITE_1 {
	my($sc, $reg, $val) = @_;
	eval q( &bus_space_write_1(($sc)-> &sc_iot, ($sc)-> &sc_ioh, ($reg), ($val)));
    }
}
unless(defined(&MALO_WRITE_2)) {
    sub MALO_WRITE_2 {
	my($sc, $reg, $val) = @_;
	eval q( &bus_space_write_2(($sc)-> &sc_iot, ($sc)-> &sc_ioh, ($reg), ($val)));
    }
}
unless(defined(&MALO_WRITE_MULTI_2)) {
    sub MALO_WRITE_MULTI_2 {
	my($sc, $reg, $off, $size) = @_;
	eval q( &bus_space_write_raw_multi_2(($sc)-> &sc_iot, ($sc)-> &sc_ioh, ($reg), ($off), ($size)));
    }
}
eval 'sub MALO_FW_HELPER_BSIZE () {256;}' unless defined(&MALO_FW_HELPER_BSIZE);
eval 'sub MALO_FW_HELPER_LOADED () {0x10;}' unless defined(&MALO_FW_HELPER_LOADED);
eval 'sub MALO_FW_MAIN_MAXRETRY () {20;}' unless defined(&MALO_FW_MAIN_MAXRETRY);
eval 'sub MALO_CMD_BUFFER_SIZE () {256;}' unless defined(&MALO_CMD_BUFFER_SIZE);
eval 'sub MALO_DEVICE_ATTACHED () {(1<< 0);}' unless defined(&MALO_DEVICE_ATTACHED);
eval 'sub MALO_FW_LOADED () {(1<< 1);}' unless defined(&MALO_FW_LOADED);
eval 'sub MALO_ASSOC_FAILED () {(1<< 2);}' unless defined(&MALO_ASSOC_FAILED);
eval 'sub MALO_BUSY () {(1<< 3);}' unless defined(&MALO_BUSY);
eval 'sub MALO_WEP_ACTION_TYPE_ADD () {0x2;}' unless defined(&MALO_WEP_ACTION_TYPE_ADD);
eval 'sub MALO_WEP_ACTION_TYPE_REMOVE () {0x4;}' unless defined(&MALO_WEP_ACTION_TYPE_REMOVE);
eval 'sub MALO_WEP_ACTION_TYPE_DEFAULT () {0x8;}' unless defined(&MALO_WEP_ACTION_TYPE_DEFAULT);
eval 'sub MALO_WEP_KEY_TYPE_40BIT () {0x1;}' unless defined(&MALO_WEP_KEY_TYPE_40BIT);
eval 'sub MALO_WEP_KEY_TYPE_104BIT () {0x2;}' unless defined(&MALO_WEP_KEY_TYPE_104BIT);
eval 'sub MALO_OID_BSS () {0x;}' unless defined(&MALO_OID_BSS);
eval 'sub MALO_OID_RATE () {0x1;}' unless defined(&MALO_OID_RATE);
eval 'sub MALO_OID_BCNPERIOD () {0x2;}' unless defined(&MALO_OID_BCNPERIOD);
eval 'sub MALO_OID_DTIMPERIOD () {0x3;}' unless defined(&MALO_OID_DTIMPERIOD);
eval 'sub MALO_OID_ASSOCTIMEOUT () {0x4;}' unless defined(&MALO_OID_ASSOCTIMEOUT);
eval 'sub MALO_OID_RTSTRESH () {0x5;}' unless defined(&MALO_OID_RTSTRESH);
eval 'sub MALO_OID_SHORTRETRY () {0x6;}' unless defined(&MALO_OID_SHORTRETRY);
eval 'sub MALO_OID_LONGRETRY () {0x7;}' unless defined(&MALO_OID_LONGRETRY);
eval 'sub MALO_OID_FRAGTRESH () {0x8;}' unless defined(&MALO_OID_FRAGTRESH);
eval 'sub MALO_OID_80211D () {0x9;}' unless defined(&MALO_OID_80211D);
eval 'sub MALO_OID_80211H () {0xa;}' unless defined(&MALO_OID_80211H);
eval 'sub MALO_RATE_BITMAP_DS1 () {(1<< 0);}' unless defined(&MALO_RATE_BITMAP_DS1);
eval 'sub MALO_RATE_BITMAP_DS2 () {(1<< 1);}' unless defined(&MALO_RATE_BITMAP_DS2);
eval 'sub MALO_RATE_BITMAP_DS5 () {(1<< 2);}' unless defined(&MALO_RATE_BITMAP_DS5);
eval 'sub MALO_RATE_BITMAP_DS11 () {(1<< 3);}' unless defined(&MALO_RATE_BITMAP_DS11);
eval 'sub MALO_RATE_BITMAP_OFDM6 () {(1<< 5);}' unless defined(&MALO_RATE_BITMAP_OFDM6);
eval 'sub MALO_RATE_BITMAP_OFDM9 () {(1<< 6);}' unless defined(&MALO_RATE_BITMAP_OFDM9);
eval 'sub MALO_RATE_BITMAP_OFDM12 () {(1<< 7);}' unless defined(&MALO_RATE_BITMAP_OFDM12);
eval 'sub MALO_RATE_BITMAP_OFDM18 () {(1<< 8);}' unless defined(&MALO_RATE_BITMAP_OFDM18);
eval 'sub MALO_RATE_BITMAP_OFDM24 () {(1<< 9);}' unless defined(&MALO_RATE_BITMAP_OFDM24);
eval 'sub MALO_RATE_BITMAP_OFDM36 () {(1<< 10);}' unless defined(&MALO_RATE_BITMAP_OFDM36);
eval 'sub MALO_RATE_BITMAP_OFDM48 () {(1<< 11);}' unless defined(&MALO_RATE_BITMAP_OFDM48);
eval 'sub MALO_RATE_BITMAP_OFDM54 () {(1<< 12);}' unless defined(&MALO_RATE_BITMAP_OFDM54);
eval 'sub MALO_RATE_BITMAP_AUTO () {0x1fef;}' unless defined(&MALO_RATE_BITMAP_AUTO);
eval 'sub MALO_TLV_TYPE_SSID () {0x;}' unless defined(&MALO_TLV_TYPE_SSID);
eval 'sub MALO_TLV_TYPE_RATES () {0x1;}' unless defined(&MALO_TLV_TYPE_RATES);
eval 'sub MALO_TLV_TYPE_PHY () {0x3;}' unless defined(&MALO_TLV_TYPE_PHY);
eval 'sub MALO_TLV_TYPE_CF () {0x4;}' unless defined(&MALO_TLV_TYPE_CF);
eval 'sub MALO_TLV_TYPE_80211D () {0x7;}' unless defined(&MALO_TLV_TYPE_80211D);
eval 'sub MALO_TLV_TYPE_CHANLIST () {0x101;}' unless defined(&MALO_TLV_TYPE_CHANLIST);
eval 'sub MALO_TLV_TYPE_NUMPROBES () {0x102;}' unless defined(&MALO_TLV_TYPE_NUMPROBES);
eval 'sub MALO_TLV_TYPE_PASSEID () {0x10a;}' unless defined(&MALO_TLV_TYPE_PASSEID);
eval 'sub CHANNELS () {12;}' unless defined(&CHANNELS);
eval 'sub MALO_RX_STATUS_OK () {0x1;}' unless defined(&MALO_RX_STATUS_OK);
1;
