require '_h2ph_pre.ph';

no warnings qw(redefine misc);

eval 'sub _PATH_DISKTAB () {"/etc/disktab";}' unless defined(&_PATH_DISKTAB);
eval 'sub DISKTAB () {"/etc/disktab";}' unless defined(&DISKTAB);
require 'machine/disklabel.ph';
require 'sys/uuid.ph';
eval 'sub MAXMAXPARTITIONS () {22;}' unless defined(&MAXMAXPARTITIONS);
if((defined(&MAXPARTITIONS) ? &MAXPARTITIONS : undef) > (defined(&MAXMAXPARTITIONS) ? &MAXMAXPARTITIONS : undef)) {
}
unless(defined(&DISKUNIT)) {
    sub DISKUNIT {
	my($dev) = @_;
	eval q(( &minor($dev) /  &MAXPARTITIONS));
    }
}
unless(defined(&DISKPART)) {
    sub DISKPART {
	my($dev) = @_;
	eval q(( &minor($dev) %  &MAXPARTITIONS));
    }
}
eval 'sub RAW_PART () {2;}' unless defined(&RAW_PART);
unless(defined(&DISKMINOR)) {
    sub DISKMINOR {
	my($unit, $part) = @_;
	eval q(((($unit) *  &MAXPARTITIONS) + ($part)));
    }
}
unless(defined(&MAKEDISKDEV)) {
    sub MAKEDISKDEV {
	my($maj, $unit, $part) = @_;
	eval q(( &makedev(($maj),  &DISKMINOR(($unit), ($part)))));
    }
}
unless(defined(&DISKLABELDEV)) {
    sub DISKLABELDEV {
	my($dev) = @_;
	eval q(( &MAKEDISKDEV( &major($dev),  &DISKUNIT($dev),  &RAW_PART)));
    }
}
eval 'sub DISKMAGIC () {(( &u_int32_t)0x82564557);}' unless defined(&DISKMAGIC);
eval 'sub MAXDISKSIZE () {0x7fffffffffff;}' unless defined(&MAXDISKSIZE);
unless(defined(&_LOCORE)) {
    eval 'sub d_packname () { ($d_un->{un_d_packname});}' unless defined(&d_packname);
    eval 'sub d_boot0 () { ($d_un->{un_b}->{un_d_boot0});}' unless defined(&d_boot0);
    eval 'sub d_boot1 () { ($d_un->{un_b}->{un_d_boot1});}' unless defined(&d_boot1);
    eval 'sub NDDATA () {5;}' unless defined(&NDDATA);
    eval 'sub NSPARE () {4;}' unless defined(&NSPARE);
}
unless(defined(&DISKLABELV1_FFS_FRAGBLOCK)) {
    sub DISKLABELV1_FFS_FRAGBLOCK {
	my($fsize, $frag) = @_;
	eval q((($fsize) * ($frag) == 0? 0: ((( &ffs(($fsize) * ($frag)) - 13) << 3) | ( &ffs($frag)))));
    }
}
unless(defined(&DISKLABELV1_FFS_BSIZE)) {
    sub DISKLABELV1_FFS_BSIZE {
	my($i) = @_;
	eval q((($i) == 0? 0: (1<< ((($i) >> 3) + 12))));
    }
}
unless(defined(&DISKLABELV1_FFS_FRAG)) {
    sub DISKLABELV1_FFS_FRAG {
	my($i) = @_;
	eval q((($i) == 0? 0: (1<< ((($i) & 0x7) - 1))));
    }
}
unless(defined(&DISKLABELV1_FFS_FSIZE)) {
    sub DISKLABELV1_FFS_FSIZE {
	my($i) = @_;
	eval q(( &DISKLABELV1_FFS_FRAG($i) == 0? 0: ( &DISKLABELV1_FFS_BSIZE($i) /  &DISKLABELV1_FFS_FRAG($i))));
    }
}
unless(defined(&DL_GETPSIZE)) {
    sub DL_GETPSIZE {
	my($p) = @_;
	eval q(((( &u_int64_t)($p)-> &p_sizeh << 32) + ($p)-> &p_size));
    }
}
unless(defined(&DL_SETPSIZE)) {
    sub DL_SETPSIZE {
	my($p, $n) = @_;
	eval q( &do {  &u_int64_t  &x = ($n); ($p)-> &p_sizeh =  &x >> 32; ($p)-> &p_size =  &x; }  &while (0));
    }
}
unless(defined(&DL_GETPOFFSET)) {
    sub DL_GETPOFFSET {
	my($p) = @_;
	eval q(((( &u_int64_t)($p)-> &p_offseth << 32) + ($p)-> &p_offset));
    }
}
unless(defined(&DL_SETPOFFSET)) {
    sub DL_SETPOFFSET {
	my($p, $n) = @_;
	eval q( &do {  &u_int64_t  &x = ($n); ($p)-> &p_offseth =  &x >> 32; ($p)-> &p_offset =  &x; }  &while (0));
    }
}
unless(defined(&DL_GETDSIZE)) {
    sub DL_GETDSIZE {
	my($d) = @_;
	eval q(((( &u_int64_t)($d)-> &d_secperunith << 32) + ($d)-> &d_secperunit));
    }
}
unless(defined(&DL_SETDSIZE)) {
    sub DL_SETDSIZE {
	my($d, $n) = @_;
	eval q( &do {  &u_int64_t  &x = ($n); ($d)-> &d_secperunith =  &x >> 32; ($d)-> &d_secperunit =  &x; }  &while (0));
    }
}
unless(defined(&DL_GETBSTART)) {
    sub DL_GETBSTART {
	my($d) = @_;
	eval q(((( &u_int64_t)($d)-> &d_bstarth << 32) + ($d)-> &d_bstart));
    }
}
unless(defined(&DL_SETBSTART)) {
    sub DL_SETBSTART {
	my($d, $n) = @_;
	eval q( &do {  &u_int64_t  &x = ($n); ($d)-> &d_bstarth =  &x >> 32; ($d)-> &d_bstart =  &x; }  &while (0));
    }
}
unless(defined(&DL_GETBEND)) {
    sub DL_GETBEND {
	my($d) = @_;
	eval q(((( &u_int64_t)($d)-> &d_bendh << 32) + ($d)-> &d_bend));
    }
}
unless(defined(&DL_SETBEND)) {
    sub DL_SETBEND {
	my($d, $n) = @_;
	eval q( &do {  &u_int64_t  &x = ($n); ($d)-> &d_bendh =  &x >> 32; ($d)-> &d_bend =  &x; }  &while (0));
    }
}
unless(defined(&DL_BLKSPERSEC)) {
    sub DL_BLKSPERSEC {
	my($d) = @_;
	eval q((($d)-> &d_secsize /  &DEV_BSIZE));
    }
}
unless(defined(&DL_SECTOBLK)) {
    sub DL_SECTOBLK {
	my($d, $n) = @_;
	eval q((($n) *  &DL_BLKSPERSEC($d)));
    }
}
unless(defined(&DL_BLKTOSEC)) {
    sub DL_BLKTOSEC {
	my($d, $n) = @_;
	eval q((($n) /  &DL_BLKSPERSEC($d)));
    }
}
unless(defined(&DL_BLKOFFSET)) {
    sub DL_BLKOFFSET {
	my($d, $n) = @_;
	eval q(((($n) %  &DL_BLKSPERSEC($d)) *  &DEV_BSIZE));
    }
}
eval 'sub DTYPE_SMD () {1;}' unless defined(&DTYPE_SMD);
eval 'sub DTYPE_MSCP () {2;}' unless defined(&DTYPE_MSCP);
eval 'sub DTYPE_DEC () {3;}' unless defined(&DTYPE_DEC);
eval 'sub DTYPE_SCSI () {4;}' unless defined(&DTYPE_SCSI);
eval 'sub DTYPE_ESDI () {5;}' unless defined(&DTYPE_ESDI);
eval 'sub DTYPE_ST506 () {6;}' unless defined(&DTYPE_ST506);
eval 'sub DTYPE_HPIB () {7;}' unless defined(&DTYPE_HPIB);
eval 'sub DTYPE_HPFL () {8;}' unless defined(&DTYPE_HPFL);
eval 'sub DTYPE_FLOPPY () {10;}' unless defined(&DTYPE_FLOPPY);
eval 'sub DTYPE_CCD () {11;}' unless defined(&DTYPE_CCD);
eval 'sub DTYPE_VND () {12;}' unless defined(&DTYPE_VND);
eval 'sub DTYPE_ATAPI () {13;}' unless defined(&DTYPE_ATAPI);
eval 'sub DTYPE_RAID () {14;}' unless defined(&DTYPE_RAID);
if(defined(&DKTYPENAMES)) {
    eval 'sub DKMAXTYPES () {($sizeof{ &dktypenames} / $sizeof{ $dktypenames[0]} - 1);}' unless defined(&DKMAXTYPES);
}
eval 'sub FS_UNUSED () {0;}' unless defined(&FS_UNUSED);
eval 'sub FS_SWAP () {1;}' unless defined(&FS_SWAP);
eval 'sub FS_V6 () {2;}' unless defined(&FS_V6);
eval 'sub FS_V7 () {3;}' unless defined(&FS_V7);
eval 'sub FS_SYSV () {4;}' unless defined(&FS_SYSV);
eval 'sub FS_V71K () {5;}' unless defined(&FS_V71K);
eval 'sub FS_V8 () {6;}' unless defined(&FS_V8);
eval 'sub FS_BSDFFS () {7;}' unless defined(&FS_BSDFFS);
eval 'sub FS_MSDOS () {8;}' unless defined(&FS_MSDOS);
eval 'sub FS_BSDLFS () {9;}' unless defined(&FS_BSDLFS);
eval 'sub FS_OTHER () {10;}' unless defined(&FS_OTHER);
eval 'sub FS_HPFS () {11;}' unless defined(&FS_HPFS);
eval 'sub FS_ISO9660 () {12;}' unless defined(&FS_ISO9660);
eval 'sub FS_BOOT () {13;}' unless defined(&FS_BOOT);
eval 'sub FS_ADOS () {14;}' unless defined(&FS_ADOS);
eval 'sub FS_HFS () {15;}' unless defined(&FS_HFS);
eval 'sub FS_ADFS () {16;}' unless defined(&FS_ADFS);
eval 'sub FS_EXT2FS () {17;}' unless defined(&FS_EXT2FS);
eval 'sub FS_CCD () {18;}' unless defined(&FS_CCD);
eval 'sub FS_RAID () {19;}' unless defined(&FS_RAID);
eval 'sub FS_NTFS () {20;}' unless defined(&FS_NTFS);
eval 'sub FS_UDF () {21;}' unless defined(&FS_UDF);
if(defined(&DKTYPENAMES)) {
    eval 'sub FSMAXTYPES () {($sizeof{ &fstypenames} / $sizeof{ $fstypenames[0]} - 1);}' unless defined(&FSMAXTYPES);
}
eval 'sub D_BADSECT () {0x4;}' unless defined(&D_BADSECT);
eval 'sub D_VENDOR () {0x8;}' unless defined(&D_VENDOR);
eval 'sub d_smdflags () { $d_drivedata[0];}' unless defined(&d_smdflags);
eval 'sub D_SSE () {0x1;}' unless defined(&D_SSE);
eval 'sub d_mindist () { $d_drivedata[1];}' unless defined(&d_mindist);
eval 'sub d_maxdist () { $d_drivedata[2];}' unless defined(&d_maxdist);
eval 'sub d_sdist () { $d_drivedata[3];}' unless defined(&d_sdist);
eval 'sub d_precompcyl () { $d_drivedata[0];}' unless defined(&d_precompcyl);
eval 'sub d_gap3 () { $d_drivedata[1];}' unless defined(&d_gap3);
eval 'sub d_blind () { $d_drivedata[0];}' unless defined(&d_blind);
unless(defined(&_LOCORE)) {
    eval 'sub GPTSECTOR () {1;}' unless defined(&GPTSECTOR);
    eval 'sub GPTSIGNATURE () {0x5452415020494645;}' unless defined(&GPTSIGNATURE);
    eval 'sub GPTREVISION () {0x10000;}' unless defined(&GPTREVISION);
    eval 'sub NGPTPARTITIONS () {128;}' unless defined(&NGPTPARTITIONS);
    eval 'sub GPTDOSACTIVE () {0x2;}' unless defined(&GPTDOSACTIVE);
    eval 'sub GPTMINHDRSIZE () {92;}' unless defined(&GPTMINHDRSIZE);
    eval 'sub GPTMINPARTSIZE () {128;}' unless defined(&GPTMINPARTSIZE);
    eval 'sub GPT_PARTSPERSEC {
        my($gh) = @_;
	    eval q(( &DEV_BSIZE /  &letoh32(($gh)-> &gh_part_size)));
    }' unless defined(&GPT_PARTSPERSEC);
    eval 'sub GPT_SECOFFSET {
        my($gh, $n) = @_;
	    eval q((($gh)-> &gh_part_size * $n));
    }' unless defined(&GPT_SECOFFSET);
    eval 'sub GPT_UUID_UNUSED () {{ 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x, 0x };}' unless defined(&GPT_UUID_UNUSED);
    eval 'sub GPT_UUID_MSDOS () {{ 0xeb, 0xd0, 0xa0, 0xa2, 0xb9, 0xe5, 0x44, 0x33, 0x87, 0xc0, 0x68, 0xb6, 0xb7, 0x26, 0x99, 0xc7 };}' unless defined(&GPT_UUID_MSDOS);
    eval 'sub GPT_UUID_EFI_SYSTEM () {{ 0xc1, 0x2a, 0x73, 0x28, 0xf8, 0x1f, 0x11, 0xd2, 0xba, 0x4b, 0x, 0xa0, 0xc9, 0x3e, 0xc9, 0x3b };}' unless defined(&GPT_UUID_EFI_SYSTEM);
    eval 'sub GPT_UUID_LEGACY_MBR () {{ 0x2, 0x4d, 0xee, 0x41, 0x33, 0x37, 0x11, 0xd3, 0x9d, 0x69, 0x, 0x8, 0xc7, 0x81, 0xf3, 0x9f };}' unless defined(&GPT_UUID_LEGACY_MBR);
    eval 'sub GPT_UUID_OPENBSD () {{ 0x82, 0x4c, 0xc7, 0xa0, 0x36, 0xa8, 0x11, 0xe3, 0x89, 0xa, 0x95, 0x25, 0x19, 0xad, 0x3f, 0x61 };}' unless defined(&GPT_UUID_OPENBSD);
    eval 'sub GPT_UUID_CHROMEROOTFS () {{ 0x3c, 0xb8, 0xe2, 0x2, 0x3b, 0x7e, 0x47, 0xdd, 0x8a, 0x3c, 0x7f, 0xf2, 0xa1, 0x3c, 0xfc, 0xec };}' unless defined(&GPT_UUID_CHROMEROOTFS);
    eval 'sub GPT_UUID_LINUX () {{ 0xf, 0xc6, 0x3d, 0xaf, 0x84, 0x83, 0x47, 0x72, 0x8e, 0x79, 0x3d, 0x69, 0xd8, 0x47, 0x7d, 0xe4 };}' unless defined(&GPT_UUID_LINUX);
    eval 'sub GPT_UUID_LINUX_HOME () {{ 0x93, 0x3a, 0xc7, 0xe1, 0x2e, 0xb4, 0x4f, 0x13, 0xb8, 0x44, 0xe, 0x14, 0xe2, 0xae, 0xf9, 0x15 };}' unless defined(&GPT_UUID_LINUX_HOME);
    eval 'sub GPT_UUID_LINUX_SRV () {{ 0x3b, 0x8f, 0x84, 0x25, 0x20, 0xe0, 0x4f, 0x3b, 0x90, 0x7f, 0x1a, 0x25, 0xa7, 0x6f, 0x98, 0xe8 };}' unless defined(&GPT_UUID_LINUX_SRV);
    eval 'sub GPT_UUID_FBSD_DATA () {{ 0x51, 0x6e, 0x7c, 0xb4, 0x6e, 0xcf, 0x11, 0xd6, 0x8f, 0xf8, 0x, 0x2, 0x2d, 0x9, 0x71, 0x2b };}' unless defined(&GPT_UUID_FBSD_DATA);
    eval 'sub GPT_UUID_FBSD_UFS () {{ 0x51, 0x6e, 0x7c, 0xb6, 0x6e, 0xcf, 0x11, 0xd6, 0x8f, 0xf8, 0x, 0x2, 0x2d, 0x9, 0x71, 0x2b };}' unless defined(&GPT_UUID_FBSD_UFS);
    eval 'sub GPT_UUID_NBSD_UFS () {{ 0x49, 0xf4, 0x8d, 0x5a, 0xb1, 0xe, 0x11, 0xdc, 0xb9, 0x9b, 0x, 0x19, 0xd1, 0x87, 0x96, 0x48 };}' unless defined(&GPT_UUID_NBSD_UFS);
    eval 'sub GPT_UUID_APPLE_HFS () {{ 0x48, 0x46, 0x53, 0x, 0x, 0x, 0x11, 0xaa, 0xaa, 0x11, 0x, 0x30, 0x65, 0x43, 0xec, 0xac };}' unless defined(&GPT_UUID_APPLE_HFS);
    eval 'sub GPT_UUID_APPLE_UFS () {{ 0x55, 0x46, 0x53, 0x, 0x, 0x, 0x11, 0xaa, 0xaa, 0x11, 0x, 0x30, 0x65, 0x43, 0xec, 0xac };}' unless defined(&GPT_UUID_APPLE_UFS);
    eval 'sub DOS_LABELSECTOR () {1;}' unless defined(&DOS_LABELSECTOR);
    eval 'sub DOSBBSECTOR () {0;}' unless defined(&DOSBBSECTOR);
    eval 'sub DOSPARTOFF () {446;}' unless defined(&DOSPARTOFF);
    eval 'sub DOSDISKOFF () {444;}' unless defined(&DOSDISKOFF);
    eval 'sub NDOSPART () {4;}' unless defined(&NDOSPART);
    eval 'sub DOSACTIVE () {0x80;}' unless defined(&DOSACTIVE);
    eval 'sub DOSMBR_SIGNATURE () {(0xaa55);}' unless defined(&DOSMBR_SIGNATURE);
    eval 'sub DOSMBR_SIGNATURE_OFF () {(0x1fe);}' unless defined(&DOSMBR_SIGNATURE_OFF);
    eval 'sub DOS_MAXEBR () {256;}' unless defined(&DOS_MAXEBR);
    eval 'sub DPSECT {
        my($s) = @_;
	    eval q((($s) & 0x3f));
    }' unless defined(&DPSECT);
    eval 'sub DPCYL {
        my($c, $s) = @_;
	    eval q((($c) + ((($s) & 0xc0) << 2)));
    }' unless defined(&DPCYL);
    eval 'sub DOSPTYP_UNUSED () {0x;}' unless defined(&DOSPTYP_UNUSED);
    eval 'sub DOSPTYP_FAT12 () {0x1;}' unless defined(&DOSPTYP_FAT12);
    eval 'sub DOSPTYP_FAT16S () {0x4;}' unless defined(&DOSPTYP_FAT16S);
    eval 'sub DOSPTYP_EXTEND () {0x5;}' unless defined(&DOSPTYP_EXTEND);
    eval 'sub DOSPTYP_FAT16B () {0x6;}' unless defined(&DOSPTYP_FAT16B);
    eval 'sub DOSPTYP_NTFS () {0x7;}' unless defined(&DOSPTYP_NTFS);
    eval 'sub DOSPTYP_FAT32 () {0xb;}' unless defined(&DOSPTYP_FAT32);
    eval 'sub DOSPTYP_FAT32L () {0xc;}' unless defined(&DOSPTYP_FAT32L);
    eval 'sub DOSPTYP_FAT16L () {0xe;}' unless defined(&DOSPTYP_FAT16L);
    eval 'sub DOSPTYP_EXTENDL () {0xf;}' unless defined(&DOSPTYP_EXTENDL);
    eval 'sub DOSPTYP_ONTRACK () {0x54;}' unless defined(&DOSPTYP_ONTRACK);
    eval 'sub DOSPTYP_LINUX () {0x83;}' unless defined(&DOSPTYP_LINUX);
    eval 'sub DOSPTYP_FREEBSD () {0xa5;}' unless defined(&DOSPTYP_FREEBSD);
    eval 'sub DOSPTYP_OPENBSD () {0xa6;}' unless defined(&DOSPTYP_OPENBSD);
    eval 'sub DOSPTYP_NETBSD () {0xa9;}' unless defined(&DOSPTYP_NETBSD);
    if(defined(&_KERNEL)) {
	if(defined(&GPT)) {
	}
	if(defined(&CD9660)) {
	}
	if(defined(&UDF)) {
	}
    }
}
if(!defined(&_KERNEL)  && !defined(&_LOCORE)) {
    require 'sys/cdefs.ph';
}
1;
